Index: LMDZ.3.3/branches/rel-LF/libf/bibio/initdynav.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/bibio/initdynav.F	(revision 350)
+++ LMDZ.3.3/branches/rel-LF/libf/bibio/initdynav.F	(revision 353)
@@ -1,2 +1,5 @@
+c
+c $Header$
+c
       subroutine initdynav(infile,day0,anne0,tstep,t_ops,t_wrt
      .                     ,nq,fileid)
Index: LMDZ.3.3/branches/rel-LF/libf/bibio/initfluxsto.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/bibio/initfluxsto.F	(revision 350)
+++ LMDZ.3.3/branches/rel-LF/libf/bibio/initfluxsto.F	(revision 353)
@@ -66,5 +66,5 @@
       integer uhoriid, vhoriid, thoriid, zvertiid,dhoriid,dvertiid
       integer ii,jj
-      integer zan
+      integer zan, idayref
       logical ok_sync
 C
@@ -79,8 +79,8 @@
 C         
 
-      zan = anne_ini
-      CALL ymds2ju(zan, 1, 1, 0.0, zjulian)
-      zjulian = zjulian + day_ini
-      tau0 = 0
+      zan = annee_ref
+      idayref = day_ref
+      CALL ymds2ju(zan, 1, idayref, 0.0, zjulian)
+      tau0 = itau_dyn
 	
 	do jj = 1, jjp1
@@ -91,5 +91,5 @@
       enddo
  
-      call histbeg(infile, iip1, rlong, jjp1, rlat,
+      call histbeg(infile, iip1, rlong(:,1), jjp1, rlat(1,:),
      .             1, iip1, 1, jjp1,
      .             tau0, zjulian, tstep, uhoriid, fileid)
@@ -107,5 +107,5 @@
       enddo
 
-      call histbeg('fluxstokev.nc', iip1, rlong, jjm, rlat,
+      call histbeg('fluxstokev.nc', iip1, rlong(:,1), jjm, rlat(1,:),
      .             1, iip1, 1, jjm,
      .             tau0, zjulian, tstep, vhoriid, filevid)
Index: LMDZ.3.3/branches/rel-LF/libf/bibio/inithist.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/bibio/inithist.F	(revision 350)
+++ LMDZ.3.3/branches/rel-LF/libf/bibio/inithist.F	(revision 353)
@@ -64,5 +64,5 @@
       integer uhoriid, vhoriid, thoriid, zvertiid
       integer ii,jj
-      integer zan
+      integer zan, dayref
 C
 C  Initialisations
@@ -76,7 +76,7 @@
 
       zan = anne0
-      CALL ymds2ju(zan, 1, 1, 0.0, zjulian)
-      zjulian = zjulian + day0
-      tau0 = 0
+      dayref = day0
+      CALL ymds2ju(zan, 1, dayref, 0.0, zjulian)
+      tau0 = itau_dyn
       
       do jj = 1, jjp1
@@ -87,5 +87,5 @@
       enddo
        
-      call histbeg(infile, iip1, rlong, jjp1, rlat,
+      call histbeg(infile, iip1, rlong(:,1), jjp1, rlat(1,:),
      .             1, iip1, 1, jjp1,
      .             tau0, zjulian, tstep, uhoriid, fileid)
@@ -102,5 +102,5 @@
       enddo
 
-      call histbeg('dyn_histv.nc', iip1, rlong, jjm, rlat,
+      call histbeg('dyn_histv.nc', iip1, rlong(:,1), jjm, rlat(1,:),
      .             1, iip1, 1, jjm,
      .             tau0, zjulian, tstep, vhoriid, filevid)
Index: LMDZ.3.3/branches/rel-LF/libf/bibio/writedynav.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/bibio/writedynav.F	(revision 350)
+++ LMDZ.3.3/branches/rel-LF/libf/bibio/writedynav.F	(revision 353)
@@ -64,4 +64,5 @@
       REAL vnat(ip1jm,llm),unat(ip1jmp1,llm) 
       logical ok_sync
+      integer itau_w
 C
 C  Initialisations
@@ -76,4 +77,5 @@
       vnat = 999.999
       unat = 999.999
+      itau_w = itau_dyn + time
 
 C Passage aux composantes naturelles du vent
@@ -86,5 +88,5 @@
 C
       call gr_u_scal(llm, unat, us)
-      call histwrite(histid, 'u', time, us, 
+      call histwrite(histid, 'u', itau_w, us, 
      .               iip1*jjp1*llm, ndex3d)
 C
@@ -92,10 +94,10 @@
 C
       call gr_v_scal(llm, vnat, vs)
-      call histwrite(histid, 'v', time, vs, 
+      call histwrite(histid, 'v', itau_w, vs, 
      .               iip1*jjp1*llm, ndex3d)
 C
 C  Temperature potentielle moyennee
 C
-      call histwrite(histid, 'theta', time, teta, 
+      call histwrite(histid, 'theta', itau_w, teta, 
      .                iip1*jjp1*llm, ndex3d)
 C
@@ -105,10 +107,10 @@
         tm(ii) = teta(ii) * ppk(ii)/cpp
       enddo
-      call histwrite(histid, 'temp', time, tm, 
+      call histwrite(histid, 'temp', itau_w, tm, 
      .                iip1*jjp1*llm, ndex3d)
 C
 C  Geopotentiel
 C
-      call histwrite(histid, 'phi', time, phi, 
+      call histwrite(histid, 'phi', itau_w, phi, 
      .                iip1*jjp1*llm, ndex3d)
 C
@@ -122,5 +124,5 @@
             WRITE(str(2:3),'(i2.2)') iq
           ENDIF
-          call histwrite(histid, str, time, q(:,:,iq), 
+          call histwrite(histid, str, itau_w, q(:,:,iq), 
      .                   iip1*jjp1*llm, ndex3d)
         enddo
@@ -129,13 +131,13 @@
 C  Masse
 C
-       call histwrite(histid, 'masse', time, masse, iip1*jjp1, ndex2d)
+       call histwrite(histid, 'masse', itau_w, masse, iip1*jjp1, ndex2d)
 C
 C  Pression au sol
 C
-       call histwrite(histid, 'ps', time, ps, iip1*jjp1, ndex2d)
+       call histwrite(histid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
 C
 C  Geopotentiel au sol
 C
-       call histwrite(histid, 'phis', time, phis, iip1*jjp1, ndex2d)
+       call histwrite(histid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
 C
 C  Fin
Index: LMDZ.3.3/branches/rel-LF/libf/bibio/writehist.F
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/bibio/writehist.F	(revision 350)
+++ LMDZ.3.3/branches/rel-LF/libf/bibio/writehist.F	(revision 353)
@@ -63,4 +63,5 @@
       character*3 str
       logical ok_sync
+      integer itau_w
 C
 C  Initialisations
@@ -71,4 +72,5 @@
       ndex2d = 0
       ok_sync =.TRUE.
+      itau_w = itau_dyn + time
 C
 C  Appels a histwrite pour l'ecriture des variables a sauvegarder
@@ -76,5 +78,5 @@
 C  Vents U
 C
-      call histwrite(histid, 'ucov', time, ucov, 
+      call histwrite(histid, 'ucov', itau_w, ucov, 
      .               iip1*jjp1*llm, ndexu)
 
@@ -82,5 +84,5 @@
 C  Vents V
 C
-      call histwrite(histvid, 'vcov', time, vcov, 
+      call histwrite(histvid, 'vcov', itau_w, vcov, 
      .               iip1*jjm*llm, ndexv)
 
@@ -88,10 +90,10 @@
 C  Temperature potentielle
 C
-      call histwrite(histid, 'teta', time, teta, 
+      call histwrite(histid, 'teta', itau_w, teta, 
      .                iip1*jjp1*llm, ndexu)
 C
 C  Geopotentiel
 C
-      call histwrite(histid, 'phi', time, phi, 
+      call histwrite(histid, 'phi', itau_w, phi, 
      .                iip1*jjp1*llm, ndexu)
 C
@@ -105,5 +107,5 @@
             WRITE(str(2:3),'(i2.2)') iq
           ENDIF
-          call histwrite(histid, str, time, q(:,:,iq), 
+          call histwrite(histid, str, itau_w, q(:,:,iq), 
      .                   iip1*jjp1*llm, ndexu)
         enddo
@@ -112,13 +114,13 @@
 C  Masse
 C
-      call histwrite(histid, 'masse', time, masse, iip1*jjp1, ndex2d)
+      call histwrite(histid, 'masse', itau_w, masse, iip1*jjp1, ndex2d)
 C
 C  Pression au sol
 C
-      call histwrite(histid, 'ps', time, ps, iip1*jjp1, ndex2d)
+      call histwrite(histid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
 C
 C  Geopotentiel au sol
 C
-      call histwrite(histid, 'phis', time, phis, iip1*jjp1, ndex2d)
+      call histwrite(histid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
 C
 C  Fin
Index: LMDZ.3.3/branches/rel-LF/libf/bibio/writephys.F90
===================================================================
--- LMDZ.3.3/branches/rel-LF/libf/bibio/writephys.F90	(revision 350)
+++ LMDZ.3.3/branches/rel-LF/libf/bibio/writephys.F90	(revision 353)
@@ -93,4 +93,5 @@
   real, dimension(llm) :: zlev
   real                 :: date0, dtime
+  integer              :: itau_deb
 !
 ! Variables locales
@@ -121,6 +122,6 @@
 ! Initialisation du fichier
 !
-  call histbeg(nom_fichier, iim, temp_lon, jjm, temp_lat, &
-     &                 1, iim, 1, jjm, 0, date0, dtime, &
+  call histbeg(nom_fichier, iim, temp_lon(:,1), jjm, temp_lat(1,:), &
+     &                 1, iim, 1, jjm, itau_deb, date0, dtime, &
      &                 nhori, file_id)
   call histvert(file_id, "presnivs", "Vertical levels", "mb", &